#!/usr/bin/env bash
#location we start looking fo code repositories
update_dir="code/"

function update_git() {
  #grab most recent refs
  git remote update &> /dev/null

  #check if we need to update
  LOCAL=$(git rev-parse @)
  REMOTE=$(git rev-parse @{u})

  #check status of repo then react
  if [ "$LOCAL" == "$REMOTE" ]; then
      echo 1 #no change occurred
  elif [ "$LOCAL" == "$BASE" ]; then
      #TODO make it so we just see a download progress bar for each repository
      git pull --ff-only
      echo 1 #change occurred
  else
      echo "Diverged"
      echo 2
  fi

  #don't need these now but they might be useful later
  #BASE=$(git merge-base @ @{u})      
  #elif [ $REMOTE = $BASE ]; then
  #    echo "Need to push"
}

function update_svn() {
  echo 0
}

function update_hg() {
  echo 0
}


#print count updates
#    $1 repo type
#    $2 total repo's checked count
#    $3 repos that were updated
function print_counts() {
  echo ">$2 $1 repositories checked."
  echo ">$3 $1 repositories have been updated."
}


#setup count variables for each repo 
##(TODO there is probably a better way to do this)
count_git_total=0
count_git_changed=0
count_svn_total=0
count_svn_changed=0
count_hg_total=0
count_hg_changed=0

repo=

#find all paths that have a -repo_type i.e. minetest-git/
#    these should contain a .git/svn/hg/etc folder.
#    prune means we will not search below those directories so be warned. 
while read repo; do 

  #get what type of repository it is
  repo_type=${repo##*-}
  
  # cd to the dir that contains the repo:
  cd ${repo}

  echo "Updating ${repo##*/}"

  was_updated=$(update_$repo_type)
  
  (( "count_"$repo_type"_total"++ ))
  
  if [[ $was_updated == 1 ]]; then
    (( "count_"$repo_type"_changed"++ ))
    echo " done. updates acquired."
  else
    echo " done. No changes to repository."
  fi

  # cd back:
  cd - &> /dev/null

done < <(find "$update_dir" -type d -regex ".*\-\(git\|svn\|hg\)" -prune)

#Print out a summery
echo 
echo "=======Status Summery========"
echo "Git"
print_counts git $count_git_total $count_git_changed
echo "Subversion"
print_counts svn $count_svn_total $count_svn_changed
echo "Mercurial"
print_counts hg  $count_hg_total  $count_hg_changed

